
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>改善OpenStack上DHCP的性能 【已翻译100%】 / iVAN</title>

    <meta name="description" content="改善OpenStack上DHCP的性能 【已翻译100%】 你有没有碰到过OpenStack中,VM失去IP地址的问题?如果有的话,你知道那可能是什么问题 --特别是如果你拥有大量的节点和VM.你的客户会因为没有明显原因却断了与VM的连接而感到 挫败.甚至云的支持团队会为log文件里没有提示却出现问题感到挫败. 听起来很熟悉? 在这篇blog里,我将会分享我的一些关于Openstack网络的经验,特别是承担为VM分配IP地址的责任的DHCP子组件. 为什么我们会把问题归咎于DHCP组件?因为这些特定的问通常都是由这个小但明显微不足道的OpenStack组">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">改善OpenStack上DHCP的性能 【已翻译100%】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>你有没有碰到过OpenStack中，VM失去IP地址的问题？如果有的话，你知道那可能是什么问题  <br />——特别是如果你拥有大量的节点和VM。你的客户会因为没有明显原因却断了与VM的连接而感到 挫败。甚至云的支持团队会为log文件里没有提示却出现问题感到挫败。</p>
<p>听起来很熟悉？</p>
<p>在这篇blog里，我将会分享我的一些关于Openstack网络的经验，特别是承担为VM分配IP地址的责任的DHCP子组件。</p>
<p>为什么我们会把问题归咎于DHCP组件？因为这些特定的问通常都是由这个小但明显微不足道的OpenStack组件导致的。 <br />**<br />DHCP agent和DNSmasq **</p>
<p>在OpenStack中，neutron-dhcp-agent为实例提供ip地址。理论上，neutron-dhcp-agent可以支持多种</p>
<p>后端，但现在它只支持dnsmasq。当启动一个实例时，分配和配置（ip）的程序包含一个在dnsmasq config中储存ip地址的进程，接着启动或重载dnsmasq。通常，OpenStack在每个网络中只有一个neutron-dhcp-agent负责spawn一个dnsmasq，所以一个庞大的网络（包含所有子网）中只会有一个dnsmasq提供服务。理论上，并且根据实用的实验室测试，dnsmasq应该能每秒处理1000个DHCP请求，但这里有些事实要说明下：</p>
<p>1.租赁时间。默认情况下是120s，你大概会知道，在租赁时间内，dhcp客户端会尝试中途延长租赁时间。这意味着每个VM会一分钟更新一次他们的ip地址。</p>
<p>2.去启动一个包含65535个静态租赁的DNSmasq实例几乎需要4分钟（3分43秒）。一般这会发生在neutron为新的VM分配新的ip地址，接着强行reload DNSmasq时。在此时，将没有DHCP服务会为相应的私有Neutron网络提供服务。</p>
<p>3.如果你没有在dnsmasq的配置中使用no-ping选项——这是应归于对安全担忧的OpenStack的默认设置——你会因非常慢的服务速度感到痛苦，因为在dnsmasq中，一个分开的pinger进程会被用于检查所提供的ip地址是否已经在使用中。包含no-ping选项，dnsmasq将能在10分钟内为160个请求提供服务并且不会失去它们，尽管这依赖于核心（core）速度和CPU速度。</p>
<p>4.Ubuntu和CentOS有mac地址表（neighbour table）被限制到/128/512/1024(net.ipv4.neigh.default.gc_thresh1/2/3）个记录。因为如此，不经常使用的 IP 记录将会异常快速老化（IP records that are not frequently used will age abnormally fast）这会影响网络性能并拖慢系统把流量发送至dhcp agent所在节点上的正确的mac地址的能力。</p>
<p>5.企图通过显著的增加ip的租赁时间去解决这些性能问题，这会导致neutron释放ip地址这方面的大问题（如果你的云负载均衡地改变)。默认情况下，neutron会为一个VM分配一个ip地址达24小时（neutron will allocate an IP address to a VM for 24 hours），独立于实际的租赁时间。当然，默认情况下，neutron不会为已经终止了的实例提供ip地址直至24小时。</p>
<p>你可以采取的措施  <br />幸运的是，你可以做点事解决问题，如果你使用openstack并拥有一个地址空间大于255个地址（/24）的私有网络，  <br />接着你应该考虑调整dnsmasq和network节点自身的默认参数。</p>
<p>1.增加ip的租赁时间以减少每秒来自VM的尝试更新ip地址的请求数量。根据一般的场景计算新的租赁时间，  <br />记住虚拟机生命周期的平均时间。由于一个Bug，设置太大的租赁时间值会强迫OpenStack在数据库中保留这个ip地址为“used”的状态。即使VM已经被删除，因为neutron的租赁时间在数据库中，neutron将不会释放这个ip地址。</p>
<p>2.增加MAC地址表的尺寸使其能服务至少一千个主机。要做到这样，典型地，你可以设置dhcp-agent所在主机  <br />的sysctl变量（通常在/etc/sysctl.conf）。视情况，你可以在所有与网络有关的节点执行以下操作，这些变量  <br />如此设置：</p>
<pre><code>net.ipv4.neigh.default.gc_thresh1 = 1024
net.ipv4.neigh.default.gc_thresh2 = 4096
net.ipv4.neigh.default.gc_thresh3 = 8192
</code></pre>
<p>3.为DNSmasq的默认参数加上no-ping选项。这个改变能够使其每秒处理多10-20个请求，因为在被实际分配之前，dnsmasq无需再尝试ping那些ip。如果你使用OpenStack作为你的基础设施的一部分，记住，你必须谨慎地考虑这个选项。比如，如果你正使用提供者网络（provider networks）并且你的VM与其他物理服务器、设备、等等是单一L2域的组成部分，IP冲突是可能发生的的,可以造成严重破坏。  <br /><strong>Neutron社区必须思考的改变 </strong></p>
<p>不幸地，在neutron中没有任何办法能为用户解决24小时ip分配的问题（the problem of 24 hour IP allocation），这个问题应该从neutron自身的改变去解决。一个简单的解决方法是在neutron或dhcp-agent中增加一个可配置的参数以修改租赁时间，并把它用作neutron数据库中的分配周期。这个方法表面看上去很完美但是仔细检查一下，你会意识到这会大大增加neutron-api/neutron-db的负载。所以这不是一个正确或不正确的方法去解决问题。</p>
<p>取而代之的是，neutron应该在实例被终止时简单地从数据库中移除ip地址。这会解决所有问题并在云上实现  <br />动态负载和ip地址的完美重用。【实际上，这恰好是Icehouse版本的情况，尽管目前问题有所减轻】</p>
<p><strong>结论 </strong></p>
<p>正如我说的，我的所述只是覆盖了一个很小的OpenStack网络的子组件——DHCP服务。正如你所看到的， 如果配置不正确，特别是当你使用了DNSmasq的默认选项将会导致许多痛苦。上面我所推荐的希望能帮助你 了解如何选择具体的DNSmasq选项和如何根据情况调整他们</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-15 19:57:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e8%b4%9f%e8%bd%bd%e5%9d%87%e8%a1%a1/" title="负载均衡">负载均衡</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/%e7%bd%91%e7%bb%9c%e6%80%a7%e8%83%bd/" title="网络性能">网络性能</a>, <a href="https://www.iamivan.net/tag/openstack/" title="OpenStack">OpenStack</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>改善OpenStack上DHCP的性能 【已翻译100%】的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBBB0M.html" rel="bookmark">Groovy 现在可运行在 Android 系统上了！ 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在最近的GR8Conf Europe 2014期间,SpringSource/Pivotal的Groovy高级软件工程师 Cédric Champeau已经在Andriod上完成一次Groovy代码的现场pull请求的合并. Groovy开发人员为了在Android上运行Groovy已经等待好几年了.因为各种困难,它的实现被推迟了,这包括Andriod Dalvik虚拟机的不同字节码和Groovy代码的动态特性等.官方对Android的支持可能在Groovy2.4版本.InfoQ采访了 Cham			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAE1e3M.html" rel="bookmark">远程执行 Android 设备上的代码 【已翻译100&percnt;】&lpar;2&sol;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我设置好AP后,从13,119个标明有潜在漏洞的app中随机选了一些,把它们安装到接入了AP的一台Nexus 5(运行4.4.3)和一台三星XE700t(运行AOSP 4.2的x86平板).我们只不过是启动每个App,做些简单的交互操作,就成功地在超过半数的应用中触发了远程代码执行,它们加载了通过中间人代理注入的恶意代码. 为了好玩,我们把注入到一个app中javascript代码反复修改,直到显示Bromium的标志替换了原有广告. 被扰乱而显示了Bromium标志的app的UI截屏. 全是广			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn8larb.html" rel="bookmark">远程执行 Android 设备上的代码 【已翻译100&percnt;】&lpar;1&sol;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&quot;你走进一个咖啡店坐下来.等咖啡的时候,你拿出你的智能手机开始玩一款你前些天下载的游戏.接着,你继续工作并且在电梯里收邮件.在你不知情下,有攻击者获取了公司网络的地址并且不断地感染你所有同事的智能手机. 等下, 什么? 我们在Bromium实验室博客上不会谈论Android太多.但是不时地我们喜欢修修补补.近来,我的同事Thomas Coudray 和我探索了下Android远程代码执行的易损性,想弄明白易损性在现实应用中是多大的问题. 尽管权限提升技术在Android上很普遍(并形成了&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLgl78M.html" rel="bookmark">AngularJS 性能优化二三事 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在过去的两年中,angularjs 的使用率有了很大的提升.简单的双向绑定是促使其流行的主要原因之一,但与此同时,它导致了在一个应用中出现了大量的 watcher.在后台,angularJS 会执行所谓的 &quot;脏值检查&quot;.之所以要做脏值检查目的是为了检查在 &quot;scope&quot; 中的数据是否发生了变化;框架必须周期性的检测数据是否发生了变化- 脏值检查会每 40ms 更新一次.. 想想看.. 如果它需要检查超多数据的时候; Crap!! 让我们来看看如何改善 angular			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba70d2p.html" rel="bookmark">通过添加一些 gems 来提升 Rails 应用的性能 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用Rails一段时间之后,你可能就会开始吹毛求疵的想要提高它性能.这是一系列文章中第一次考虑如何提高(即使微不足道的)Rails的性能. 我将会关注在一些gem的提速上面,在某些情况下,可能是一小部分的Rails,如html转义,String.blank?和JSON工具类. 基准原则 原则,对于仅仅在控制台wrk运行几次来讲,是一个与其过强的词语,但是我这里不是来寻找&quot;圣杯&quot;的,而是提供一些初始的想法. 我将从旧的apache ab切换到wrk. wrk是现代的 HTTP 基准工具,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLEJRM.html" rel="bookmark">利用 View State 缓存优化 ASP&period;NET 性能 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 ASP.NET的视图浏览机制提供了客户端的管理方式.它能够保存请求过程中的所有数据. 这对于无状态显示的协议编程如HTTP提供了方便. ASP.NET的 View State被保存在页面上隐藏的Base64字符串中, 它记录了客户端到服务器的请求以及服务端到客户端的回应信息. &lt;input id=&quot;__VIEWSTATE&quot; type=&quot;hidden&quot; name=&quot;__VIEWSTATE&quot; value=&quot;/wEPDwUJNzg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrdDDyz.html" rel="bookmark">8 种提升 ASP&period;NET Web API 性能的方法 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ASP.NET Web API 是非常棒的技术.编写 Web API 十分容易,以致于很多开发者没有在应用程序结构设计上花时间来获得很好的执行性能. 在本文中,我将介绍8项提高 ASP.NET Web API 性能的技术. 1) 使用最快的 JSON 序列化工具 JSON 的序列化对整个 ASP.NET Web API 的性能有着关键性的影响. 在我的一个项目里,我从 JSON.NET 序列化工具转到了 ServiceStack.Text 有一年半了. 我测量过,Web API 的性能提升了20			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYXqeQb.html" rel="bookmark">在 QEMU 和 KVM 上运行 OS X Mavericks 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天,OS X虚拟化是一件很容易搞定的事情,因为OS X主机完全支持VMware和VirtualBox. 但是在裸机和QEMU上虚拟化会是什么情况呢?在Linux下呢?最终我在QEMU上完全搞定了Mavericks (没有额外内核拓展哦(!)),不过真不容易. 工作人员 许多关于这件事的工作都归于 Gabriel L. Somlo ,他完成了这件事的初步工作,然而我不能从他的指南里得到任何干净的安装引导的OS X Mavericks 版本.因此我只能自己调试了. 为什么? 云中OS X. 这是一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGw0rlz.html" rel="bookmark">在 Docker 上建立多节点的 Hadoop 集群 【已翻译100&percnt;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇文章中你已经看到了在你的devbox创建一个单点Hadoop 集群是多么简单. 现在我们提高门槛,在Docker上创建一个多点hadoop集群.在开始前,确保你有最新的Ambari镜像: docker pull sequenceiq/ambari:latest 一行命令 一旦你得到了最新的镜像,你就可以启动Docker容器.我们已经创建了几个shell 函数来帮你输入Docker命令,从而避免输入像docker run [options] image [command]这样冗长的命令. 有			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo0egM.html" rel="bookmark" class="title">dz论坛asp&period;net版配置伪静态的方法</a>
					<div>
						为了增强Url友好性,方便搜索引擎的收录,现在很多用户都希望将较长的Url带参数程序地址变成较短的程序或静态网页Url地址,例如: 将show.aspx?id=3&amp;page=4 变为show- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlXkqM.html" rel="bookmark" class="title">硅谷引领新一轮互联网泡沫？</a>
					<div>
						如果说三十年河东,三十年河西是亘古不变的真理,那么对于快节奏的互联网,十年的时间似乎可以当做一个轮回?而恰是在2001年,互联网诞生的第7 个年头,迎来了它的第一次投机泡沫.2001年伊始,一路攀升的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxN1Pz.html" rel="bookmark" class="title">FLASH MX 2004视频教程&colon;《电脑报》片头制作（六）</a>
					<div>
						教程|视频教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZlnOM.html" rel="bookmark" class="title">关于C&num;中虚方法重载的说明</a>
					<div>
						在C#中,进行虚方法的重载有些体会,现与大家分享.首先请大家看看下面的例子,using System; abstract public class contact{ public virtual st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg1qAz.html" rel="bookmark" class="title">留住永恒的画面 暴风影音截图功能体验</a>
					<div>
						说到媒体播放器的截图功能,相信很多朋友都会说,这个功能太常用了.每当看到有什么精彩的画面想和朋友们分享的时候,或者是自己DIY一些图片.海报或者搞笑图片的时候,截图功能是绝对的利器.但由于大多数用户对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW19Krz.html" rel="bookmark" class="title">网站用户体验中的可用性和易用性</a>
					<div>
						网站的用户体验中常常提及usability这个词,它既被译做可用性也被译作易用性.usability是衡量网站用户体验的重要质量指标. 设计成功的网站可以让使用者在浏览的过程中不会产生压力感挫折感,符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6Ga3b.html" rel="bookmark" class="title">隐藏excel公式的方法</a>
					<div>
						  有时使用某些excel公式,但不想被其他人知道,为了保密需要,要防止别人看到,就要用下面的方法对下面excel公式进行隐藏. 隐藏前的表格如下图,公式可以在编辑栏中或者双击单元格可以看到. 操作步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwdlYb.html" rel="bookmark" class="title">iOS版Chrome34浏览器功能特色</a>
					<div>
						  Chrome34 苹果用户也可以直接使用谷歌账户在不同设备之间同步个性化设置. iOS版Chrome34浏览器功能特色: • 在设备之间保持同步 - 您可以在笔记本电脑.手机或平板电脑上无缝访问并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYXDrb.html" rel="bookmark" class="title">Photoshop打造淡美的中性蓝绿色美女图片</a>
					<div>
						  中性图片调色相对来说比较简单,可以直接降低图片的饱和度得到初步的中性图片,然后微调高光及暗部的颜色,给图片增加淡淡的主色即可. 原图 最终效果 1.打开素材图片,创建色相/饱和度调整图层,对全图. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WYKnb.html" rel="bookmark" class="title">30个引人入胜的产品展示网页设计赏析</a>
					<div>
						  和以往相比,产品销售变得越来越困难了,残酷的竞争,逐渐压低的获利空间. 如何让目标用户直击产品,是每个商家都在苦苦思索的问题.无论是线下宣传,还是线上宣传,商家都需要利用优秀的.独一无二的手段来吸 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywPGvz.html" rel="bookmark" class="title">OFFICE2010繁复性简洁方法</a>
					<div>
						  随便打开一个OFFICE2010软件,此拿excel2010为例:打开excel,点击左上角,文件,在弹出的框中点击&quot;选项&quot;栏 其他不用设置,点击&quot;信用中心&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP829mp.html" rel="bookmark" class="title">win8系统出现蓝屏并提示错误代码0xc0000034的解决方案</a>
					<div>
						  在使用电脑过程中,最经常遇到的就是出现蓝屏错误,因为出现蓝屏错误往往意味着被迫重启,而且数据可能丢失,最近有win8系统用户发现在使用过程中出现蓝屏,并提示错误代码0xc0000034,你需要使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badDmqz.html" rel="bookmark" class="title">笔记本轻松实现无线上网功能</a>
					<div>
						现在笔记本已经是最最主流的电脑的,很多人买电脑都是先选笔记本的除了是那些公司用的电脑.基本上一台一般的笔记本已经可以解决我们日常用电脑的需要了.也就是让我们使用电脑的时候不会卡.那么一台笔记本新买过来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg32N5M.html" rel="bookmark" class="title">ThinkPHP分组下自定义标签库实例&lowbar;php实例</a>
					<div>
						本文实例讲述了ThinkPHP分组下自定义标签库的实现方法.分享给大家供大家参考.具体如下: 自定义标签库应该位于ThinkPHP\\Extend\\Driver\\TagLib目录下 1 新建标签类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR0J6z.html" rel="bookmark" class="title">java中为什么BufferedWriter 要比 FileReader高效？</a>
					<div>
						问题描述 java中为什么BufferedWriter 要比 FileReader高效? BufferedWriter 为什么比用FileReader每次读一个字符数组高效?FileReader每次读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NXr8M.html" rel="bookmark" class="title">matlab omp-OMP算法重构二维信号中遇到的运行问题</a>
					<div>
						问题描述 OMP算法重构二维信号中遇到的运行问题 Cannot find an exact (case-sensitive) match for 'DWT' The closest match is: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kKRPM.html" rel="bookmark" class="title">浏览器端的 9 种缓存机制</a>
					<div>
						浏览器端的 9 种缓存机制 浏览器缓存Browser Caching是浏览器端保存数据用于快速读取或避免重复资源请求的优化机制,有效的缓存使用可以避免重复的网络请求和浏览器快速地读取本地数据,整体上加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/bQrE10M.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei93YzdZTlBtM1l4WHlnaWFneTlWeDJkaWJTQmljYkZxR3lBQ3kxWVBIblRnN0ZJb05sOTVodXY3WDJXYURsVGF3YlhFMUxqSG9kcGZDUFpUOFF2T2FMaWI1Y3cvMA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/bQrE10M.html" rel="bookmark" class="title">李克强：把执法权力关进&amp;quot&semi;数据铁笼&amp;quot&semi; 让运行处处留痕</a>
					<div>
						李克强的&quot;大数据观&quot; &quot;大数据&quot;,这个令不少互联网企业家激动的时髦词汇,在中国总理的字典里也占有重要的一席之地 14日,李克强在贵州考察北京·贵阳大数据应用展示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2ODmb.html" rel="bookmark" class="title">gradle-android studio 中如何强行刷新 libry 引用&lpar;针对于 SNAPSHOT&rpar;</a>
					<div>
						问题描述 android studio 中如何强行刷新 libry 引用(针对于 SNAPSHOT) 工程中引用了公司maven的一个aar(SNAPSHOT) 这个SNAPSHOT更新了许多版本为何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBNeZb.html" rel="bookmark" class="title">关于myEclipse8&period;5的一个中文乱码问题</a>
					<div>
						问题描述 最近在玩swing我用的版本是8.5但是我发现我的控件上不能显示中文,全是框框....而且控件属性那栏里面的字体栏我的默认的居然是Tahoma我点进去以后里面的字体选择如果是中文的字体名,比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR3VEb.html" rel="bookmark" class="title">Internet 服务总线</a>
					<div>
						  作者:Donald F. Ferguson.Dennis Pilarinos.John Shewchuk   摘要:Web应用程序是非常常见的应用程序模型,它们将变得越来越普遍.几乎所有大中型企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDeX0lb.html" rel="bookmark" class="title">请教关于图片水印的问题</a>
					<div>
						问题描述 网上的代码都差不多找出最常用的几句://原始图片都是jpeg格式ImageoriginalImage=Image.FromFile(...);//水印图片ImagewaterMarkImag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/M1rVm3p.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei9aWWljMHQ4bHI4ZG9lSlVxNUpXTzBRWTg2YU1qNjU4YmRVcDhTeGljb2VybGFON3gwWFVhMUtIcElGb1pJdUxPajhCM0hJaWJySzJMVkY0Mzd1Zk5DZVJ3dy8w.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/M1rVm3p.html" rel="bookmark" class="title">来自宇宙的爱意：哈勃望远镜发现宇宙玫瑰</a>
					<div>
						2011年4月,为了庆祝哈勃望远镜部署21周年,天文学家将哈勃的镜头指向了一个非常上相的画面,这一组相互作用的星系,被命名为Arp273.其中较大的螺旋星系为UGC1810,受其伴侣星系UGC1813 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkedy7b.html" rel="bookmark" class="title">关于数据采集工作的一些感受</a>
					<div>
						         建工学院比较简单,大家出现的人多问题我这里都没有.既没有大三重新分专业,也没有选修课,总之问题不多.加上建工学院的教学秘书也很负责,所以我的工作就更少.         现在想想我我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqWLvb.html" rel="bookmark" class="title">我大学兼职做站的一些经验</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 前一段时间笔者的一篇文章&lt;网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn571M.html" rel="bookmark" class="title">《社交网站界面设计（原书第2版）》&mdash;&mdash;1&period;1　社交产品的一点渊源</a>
					<div>
						1.1 社交产品的一点渊源 社交产品最早始于BBS,其中最有名的当属1985年的The Well,&lt;连线&gt;杂志将其评为1997年度&quot;全球最具影响力的在线社区&quot;注1,其出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB2ywM.html" rel="bookmark" class="title">swift字典转模型。。。。。</a>
					<div>
						问题描述 swift字典转模型..... 想把服务器请求回来的数据全部放进数组中,然后将这个字典数组转成模型数组,请问应该怎么写啊?现在卡在放进数组那里了 解决方案 http://www.open-o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkEyZM.html" rel="bookmark" class="title">《机器人学经典教程》&mdash;&mdash;第1章　机器人学的定义</a>
					<div>
						第1章 机器人学的定义 机器人学经典教程 欢迎来到机器人启蒙的世界!在这里我首先要恭喜你,在对机器人的艺术.科学以及工程这些酷炫主题的研究上,你选择了一条十分精彩的道路.随着本书的开始,你即将踏上一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1qexb.html" rel="bookmark" class="title">数据-关于soap post提交问题</a>
					<div>
						问题描述 关于soap post提交问题 可以返回数据.但是好像解析有问题,所以返回的都是错误的数据 SoapObject optionObject = new SoapObject(nameSpac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j7oop.html" rel="bookmark" class="title">导入、导出mysql数据库的例子</a>
					<div>
						导入: 直接在Mysql中导入: mysql&gt;use databaseName; mysql&gt; load data infile 'filePath' into table 'tableN ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
